"{ Package: 'stx:libbasic2' }"

"{ NameSpace: Smalltalk }"

TwoDimensionalMatrix variableSubclass:#SquareMatrix
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Collections-MultiDimensional'
!


!SquareMatrix methodsFor:'matrix operations'!

determinant
    "Answer the determinant of this matrix.

    Note that if your only interest in the determinant is to decide whether or not the matrix is singular,
    you're better off using #isSingular which is not subject to numeric overflow."

    ^ self determinantByLuDecomposition

    "
     (Matrix identity:3) determinantByCofactors
    "
!

determinantByCofactors
    "Answer the determinant of this matrix."

    dimensions = #( 1 1 ) ifTrue: [ ^ self _at: 1 at: 1 ].

    "General case"

    ^(1 to: self columns) 
            inject: 0 
            into: [ :tot :c | tot + ((self _at: 1 at: c) * (self cofactor: 1@c)) ]
!

determinantByLuDecomposition
        "Answer the determinant of a matrix."

        | lu prod |

        lu := self luForm.
        prod := self luForm rowInterchangeSign.

        1 to: lu rows do: [ :i |
                (lu at: i at: i) <= lu comparisonTolerance ifTrue: [ ^0 ].
                prod := prod * (lu at: i at: i) asFraction ].

        ^prod
! !

!SquareMatrix methodsFor:'queries'!

isSquare
    ^ true
! !

!SquareMatrix class methodsFor:'documentation'!

version_CVS
    ^ '$Header$'
! !

